﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.UI;
using RapidWebDevSample;

namespace RapidWebDevSample.Controllers
{ 
    public class Default1Controller : Controller
    {
        private RapidWebDevSampleEntities db = new RapidWebDevSampleEntities();

        //lim
        // GET: /Default1/

        public ViewResult Index()
        {
            return View();
        }

        //
        // GET: /Default1/Create

        public ActionResult Create()
        {
            return View();
        } 

        //
        // POST: /Default1/Create

        [HttpPost]
        public JsonResult Create(User user)
        {
            JsonResult json=new JsonResult();
			json.Data=true;
            try{
                db.User.AddObject(user);
                db.SaveChanges();
            }
            catch(Exception ee)
            {
                json.Data=ee.Message;
            }
            
            return json;
        }
        
        //
        // GET: /Default1/Edit/5
        [OutputCache(Location = OutputCacheLocation.None)]
        public ActionResult Edit(decimal id)
        {
            User user = db.User.Single(u => u.UserID == id);
            return View(user);
        }

        //
        // POST: /Default1/Edit/5

        [HttpPost]
        [OutputCache(Location = OutputCacheLocation.None)]
        public ActionResult Edit(User user)
        {
            JsonResult json=new JsonResult();
            try
            {
                db.User.Attach(user);
                db.ObjectStateManager.ChangeObjectState(user, EntityState.Modified);
                db.SaveChanges();
            }
            catch(Exception ee)
            {
                json.Data=ee.Message;
                return json;
            }
            json.Data=true;
            return json;
        }


        //
        // POST: /Default1/Delete/5

        [HttpPost, ActionName("Delete")]
        public JsonResult DeleteConfirmed(decimal id)
        {           
            JsonResult json=new JsonResult();
			json.Data=true;
            try{ 
            User user = db.User.Single(u => u.UserID == id);
            db.User.DeleteObject(user);
            db.SaveChanges();
            }
            catch(Exception ee)
            {
                json.Data=ee.Message;
            }
            
            return json;
        }

        public JsonResult List(int page,int rows)
        {
            
            var q = from e in db.User orderby e.UserID
                    select new
                    {
                        UserID = e.UserID,
                                                UserName = e.UserName,
                                                Password = e.Password,
                                                Age = e.Age,
                                                Enable = e.Enable,
                                                Birth = e.Birth                                            };
					
			var result = q.Skip((page - 1)*rows).Take(rows).ToList();
            Dictionary<string, object> json = new Dictionary<string, object>();
            json.Add("total", q.ToList().Count);
            json.Add("rows", result);
			
            return Json(json, JsonRequestBehavior.AllowGet);
        }
		
		protected override void Dispose(bool disposing)
        {
            db.Dispose();
            base.Dispose(disposing);
        }
    }
}
